/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 3    BMPGET.C    31-Mar-93    14:06:58 #    */
/* ************************************************** */
/*    METAGRAPHICS SOFTWARE CORPORATION (c) 1993      */
/*    Demonstrates use of GetBMP()                    */
/* ************************************************** */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>

#include "metawndo.h"   /* master MetaWINDOW include file */
#include "bmplab.h"     /* BMP lab include file */


/* special stack size declaration if using Turbo or Borland C++ */
#ifdef      TurboC
extern unsigned _stklen = 14336U;  /* stack size 14K */
#endif

/* determine if running 32 bit compiler */
#ifdef MetawareC
#define __386__      /* already defined for Watcom C 386 */
#endif

/* need farmalloc and farfree ? */

#ifndef __386__
#include <malloc.h>
#endif


/* global vaiables */
int   GrafixCard,GrafixInput;


void main( int argc, char *argv[] )
{
   int      i;
   rect     scrnR;
   bmpHead  bmpHeader;        /* buffer for reading the files BMP header */
   palData  RGBInfo[256];     /* buffer for reading the files palette    */
   void     *filebuf;         /* pointer to allocated  file buffer       */
   dirRec   mydir;            /* directory record for finding file size  */
   FILE     *fp;              /* file pointer to read file into  memory  */

   /* check for a file name on the command line */
   if( argc < 2 ) {
      printf("BMPGET - Display BMP file from file buffer\n");
      printf("Usage: BMPGET filename\n");
      exit(1);
   }

   /* let user select display type */
   MetQuery(argc,argv);      

   /* init the system */
   i = InitGraphics( GrafixCard );
   if( i != 0 ) {
      printf("MetaWINDOW Initialization error #%d\n", i);
      exit(2);
   }

   /* Read BMP File Header Information */
   if ( ReadBMPInfo( argv[1], &bmpHeader, RGBInfo ) == False )  {
      printf("%s is not a valid BMP file\n", argv[1]);
      StopGraphics();
      exit(3);
   }

   /* at this point we know the file exists and is a valid BMP file */

   /* find out how big the file is */
   FileQuery( argv[1], &mydir, 1 );

   if(mydir.fileSize > 64000L){
      printf("File too Big!" );
      StopGraphics();
      exit(4);
   }

   /* allocate a buffer for the whole file  */


   /* THIS WONT WORK ON FILES LARGER THAN 64K */
   /* THE ALLOC GETS TRUNCATED BY SIZE_T CAST */
   filebuf = malloc( mydir.fileSize );
   if( filebuf == NULL ) {
      printf("Not Enough Memory" );
      StopGraphics();
      exit(4);
   }

   /* put into graphics mode */
   SetDisplay( GrafPg0 ); 

   /* clear the screen */
   ScreenRect( &scrnR );
   EraseRect( &scrnR );

   /* set palette, based on palette in BMP file */
   WritePalette( 0, 0, (int) QueryColors(), RGBInfo );

   /* load bmp file into memory */
   MoveTo(0,100); DrawString("Loading file into buffer...");
   fp = fopen( argv[1], "rb" );

   /* must read  in chunks no larger than 64K */
   fread( filebuf, 64000U, (size_t) (mydir.fileSize/64000L+1), fp );

   /* Get BMP File from file buffer */
   i = GetBMP( filebuf, NULL, NULL );
   if( i == False )  {
      MoveTo( 0,100 );
      DrawString("Can't display this file in current video mode!" );
   }

   /* wait for a key press */
   getch();

   /* free file buffer */
   free( filebuf );

   SetDisplay( TextPg0 );
   StopGraphics();
   i = QueryError();
   printf("QueryError=%d/%d\n",i >> 7,i & 127);
   exit(i);

}

#include "metquery.c"

