/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 3    BMPREAD.C    31-Mar-93    13:13:52 #    */
/* ************************************************** */
/*    METAGRAPHICS SOFTWARE CORPORATION (c) 1993      */
/*    Demonstrates use of ReadBMP()                   */
/* ************************************************** */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>

#include "metawndo.h"   /* master MetaWINDOW include file */
#include "bmplab.h"     /* BMP lab include file */


/* special stack size declaration if using Turbo or Borland C++ */
#ifdef      TurboC
extern unsigned _stklen = 14336U;  /* stack size 14K */
#endif

/* global vaiables */
int   GrafixCard,GrafixInput;


void main( int argc, char *argv[] )
{
   int      i;
   rect     scrnR;
   bmpHead  bmpHeader;        /* buffer for reading the files BMP header */
   palData  RGBInfo[256];     /* buffer for reading the files palette    */

   /* check for a file name on the command line */
   if( argc < 2 ) {
      printf("BMPREAD - Display BMP file\n");
      printf("Usage: BMPREAD filename\n");
      exit(1);
   }

   /* let user select display type */
   MetQuery(argc,argv);      

   /* init the system */
   i = InitGraphics( GrafixCard );
   if( i != 0 ) {
      printf("MetaWINDOW Initialization error #%d\n", i);
      exit(2);
   }

   /* Read BMP File Header Information */
   if ( ReadBMPInfo( argv[1], &bmpHeader, RGBInfo ) == False )  {
      printf("%s is not a valid BMP file\n", argv[1]);
      StopGraphics();
      exit(2);
   }

   /* at this point we know the file exists and is a valid BMP file */

   /* put into graphics mode */
   SetDisplay( GrafPg0 ); 

   /* clear the screen */
   ScreenRect( &scrnR );
   EraseRect( &scrnR );

   /* set palette, based on palette in BMP file */
   WritePalette( 0, 0, (int) QueryColors(), RGBInfo );

   /* Read BMP File */
   i = ReadBMP( argv[1], NULL, NULL );
   if( i == False )  {
      MoveTo( 0,100 );
      DrawString("Can't display this file in current video mode!" );
   }

   /*  wait for a key press */
   getch();

   SetDisplay( TextPg0 );
   StopGraphics();
   i = QueryError();
   printf("QueryError=%d/%d\n",i >> 7,i & 127);
   exit(i);

}

#include "metquery.c"

