/*  %kw # %v    %n    %d    %t #                      */
/*  Version # 1    PCXWORLD.C    30-Mar-93    12:37:34 #    */
/* ************************************************** */
/*    METAGRAPHICS SOFTWARE CORPORATION (c) 1993      */
/*    Sample "hello world" program                    */
/* ************************************************** */

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#include "metawndo.h"   /* master MetaWINDOW include file */
#include "pcxlab.h"     /* PCX lab include file */

/* special stack size declaration if using Turbo or Borland C++ */
#ifdef      TurboC
extern unsigned _stklen = 14336U;  /* stack size 14K */
#endif

void main( )
{
   int      i;
   rect     scrnR;
   pcxHead  pcxHeader;        /* buffer for reading the files PCX header */
   palData  RGBInfo[256];     /* buffer for reading the files palette    */
   char     *name;            /* file name pointer                       */

   /* init the system for EGA */
   i = InitGraphics( EGA640x350 );
   if( i != 0 ) {
      printf("MetaWINDOW Initialization error #%d\n", i);
      exit(2);
   }

   name = "PCXWORLD.PCX";

   /* Read PCX File Header Information */
   if ( ReadPCXInfo( name, &pcxHeader, RGBInfo ) == False )  {
      printf("%s does not exist or is not a valid PCX file\n", name);
      StopGraphics();
      exit(2);
   }

   /* put into graphics mode */
   SetDisplay( GrafPg0 ); 

   /* clear the screen */
   ScreenRect( &scrnR );
   EraseRect( &scrnR );

   /* set palette, based on palette in PCX file */
   WritePalette( 0, 0, 15, RGBInfo );

   /* Read PCX File */
   i = ReadPCX( name, NULL, NULL );
   if( i == False )  {
      MoveTo( 0,100 );
      DrawString("Can't display this file in current video mode!" );
   }

   /*  wait for a key press */
   getch();

   SetDisplay( TextPg0 );
   StopGraphics();
   i = QueryError();
   printf("QueryError=%d/%d\n",i >> 7,i & 127);
   exit(i);

}


