/*  %kw # %v    %n    %d    %t # */
/* Version # 1    BMPWRITE.C    16-Mar-93    14:36:14 # */
/* ************************************************** */
/*    METAGRAPHICS SOFTWARE CORPORATION (c) 1993      */
/*    Demonstrates use of WriteBMP()                  */
/* ************************************************** */

#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <ctype.h>
#include "metawndo.h"      /* master MetaWINDOW include file */
#include "bmplab.h"

/* special stack size declaration if using Turbo or Borland C++ */
#ifdef      TurboC
extern unsigned _stklen = 14336U;  /* stack size 14K */
#endif


void  quit( char* /*msgptr*/ ,int /*err*/ );
void  disp_patt( void );

int GrafixCard,GrafixInput;
rect  scrnR;


void main( int argc, char *argv[] )
{
	int     i;
	palData   RGBInfo[256];


   printf("\nBMPWRITE - MetaWINDOW WriteBMP Sample File");
   if( argc < 2 ){
	  printf("\nUsage: BMPWRITE filename [optional args]");
	  exit(1);
   }

   MetQuery(argc,argv);
   i = InitGraphics(GrafixCard);
   if(i !=0 )
	  GrInitErr(i);   /* display reason for no go */

   SetDisplay( GrafPg0 );
   ScreenRect( &scrnR );
   EraseRect( &scrnR );

   disp_patt();  /* draw patterns on the screen to write to BMP file */

   /* Write BMP File */
   ReadPalette( 0, 0, (int)QueryColors(), RGBInfo );  /* get palette info */

   if ( WriteBMP( argv[1], NULL, RGBInfo ) == False )  {
	  quit( "Problem writing BMP file.", 1 );
   }

	getch();
   quit( "Normal End" ,0 );
}


/* clean up and exit, print an exit message */
void quit( char *msgptr, int err )
{
   int i;

   SetDisplay(TextPg0);
   printf("\n\n%s", msgptr);
   i = QueryError();
   printf("\nQueryError=%d/%d",i >> 7,i & 127);
   if( err )
	  putch(07);
	  i = err;
   StopGraphics();
   exit(i);
}


/* do some keen patterns as a test screen */
void disp_patt()
{
   rect R1, r;
   int i,x,y,color;
   long max_colors;
   char buf[10];

   SetRect(&R1, 0,0,scrnR.Xmax,scrnR.Ymax);
   x=R1.Xmax/32; y=R1.Ymax/32;
   for (i=0 ; i<16; i++)
   { 
	  PenColor(i);
	  BackColor(15-i);
	  FillRect(&R1,i+16);
	  FrameRect(&R1);
	  InsetRect(&R1,x,y);
   }

	/* set a virtual coordinate system of 1000x1000 */
   /*
	SetRect( &scrnR, 0, 0, 1000, 1000 );
	VirtualRect( &scrnR );

	MoveTo( 0,0 );

	max_colors= QueryColors();
	if(max_colors  > 16 ) {
	  SetRect( &r, 0, 0, 30, 40 );

	  for( color = 0; color <= max_colors; color++ ) {
		PenColor( color );
		PaintRect( &r );
		PenColor( White );
		FrameRect( &r );
		OffsetRect( &r, 40, 0 );

		if( r.Xmax > 640 ) {
			r.Xmin = 0; r.Xmax = 30;
			OffsetRect( &r, 0, 50 );
		}

	  }

   }
   else {

	  SetRect( &r, 0, 0, 100, 100 );

	  for( color = 0; color <= max_colors; color++ )  {
		PenColor( color );
		PaintRect( &r );
		PenColor( White );
		FrameRect( &r );
		MoveTo( r.Xmin + 49, r.Ymax + 35 );
		sprintf( buf, "%d", color );
		DrawString( buf );
		OffsetRect( &r, 150, 0 );

		if( r.Xmax > 599 ) {
			r.Xmin = 0; r.Xmax = 100;
			OffsetRect( &r, 0, 200 );
		}

	  }

   }
	SetLocal();
   */

}

#include "metquery.c"
