/*  %kw # %v    %n    %d    %t #                          */
/*  Version # 2    FINDBEST.C    26-Jul-94    11:00:08 #    */
/**********************************************************/
/* FINDBEST                                               */
/*                                                        */
/* Description: uses the FindBest utilities in METFIND.C  */
/* to automatically determine the best graphics mode.     */
/*                                                        */
/**********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "metawndo.h"      /* master MetaWINDOW include file */

#include "metfind.c"       /* FindBest utilities */

void main( int argc, char *argv[] )
{
   int   i, xres, yres;
   long colors;
   char *info;

   /* first see if there are command line choices */
   i = FindUserDisplay( argc, argv );

   /* if not, prompt for limts */
   if( i == 0 ) {

      printf("Enter max x = ");
      scanf( "%d", &xres );
      printf("\n");
      printf("Enter max y = ");
      scanf( "%d", &yres );
      printf("\n");
      printf("Enter max colors = ");
      scanf( "%ld", &colors );
      printf("\n");

      /* see what comes back */
      i = FindBestDisplay( xres, yres, colors );
   }

   /* print out a description */
   info = FindDisplayInfo( i, &xres, &yres, &colors );
   printf("%dx%d %ld colors %s number %x\n", xres, yres, colors, info, i );
}



